]>
Commit | Line | Data |
---|---|---|
1 | #!/bin/sh | |
2 | ||
3 | set -e | |
4 | ||
5 | # We don't use a secret keyring, of course, but gpg panics and | |
6 | # implodes if there isn't one available | |
7 | ||
8 | GPG_CMD="gpg --ignore-time-conflict --no-options --no-default-keyring --secret-keyring /etc/apt/secring.gpg --trustdb-name /etc/apt/trustdb.gpg" | |
9 | GPG="$GPG_CMD --keyring /etc/apt/trusted.gpg" | |
10 | ||
11 | ||
12 | MASTER_KEYRING="" | |
13 | ARCHIVE_KEYRING_URI="" | |
14 | #MASTER_KEYRING=/usr/share/keyrings/debian-master-keyring.gpg | |
15 | #ARCHIVE_KEYRING_URI=http://ftp.debian.org/debian/debian-archive-keyring.gpg | |
16 | ||
17 | ARCHIVE_KEYRING=/usr/share/keyrings/debian-archive-keyring.gpg | |
18 | REMOVED_KEYS=/usr/share/keyrings/debian-archive-removed-keys.gpg | |
19 | ||
20 | add_keys_with_verify_against_master_keyring() { | |
21 | ADD_KEYRING=$1 | |
22 | MASTER=$2 | |
23 | ||
24 | if [ ! -f "$ADD_KEYRING" ]; then | |
25 | echo "ERROR: '$ADD_KEYRING' not found" | |
26 | return | |
27 | fi | |
28 | if [ ! -f "$MASTER" ]; then | |
29 | echo "ERROR: '$MASTER' not found" | |
30 | return | |
31 | fi | |
32 | ||
33 | # when adding new keys, make sure that the archive-master-keyring | |
34 | # is honored. so: | |
35 | # all keys that are exported must have a valid signature | |
36 | # from a key in the $distro-master-keyring | |
37 | add_keys=`$GPG_CMD --keyring $ADD_KEYRING --with-colons --list-keys | grep ^pub | cut -d: -f5` | |
38 | master_keys=`$GPG_CMD --keyring $MASTER --with-colons --list-keys | grep ^pub | cut -d: -f5` | |
39 | for add_key in $add_keys; do | |
40 | ADDED=0 | |
41 | for master_key in $master_keys; do | |
42 | if $GPG_CMD --keyring $ADD_KEYRING --list-sigs --with-colons $add_key | grep ^sig | cut -d: -f5 | grep -q $master_key; then | |
43 | $GPG_CMD --quiet --batch --keyring $ADD_KEYRING --export $add_key | $GPG --import | |
44 | ADDED=1 | |
45 | fi | |
46 | done | |
47 | if [ $ADDED = 0 ]; then | |
48 | echo >&2 "Key '$add_key' not added. It is not signed with a master key" | |
49 | fi | |
50 | done | |
51 | } | |
52 | ||
53 | # update the current archive signing keyring from a network URI | |
54 | # the archive-keyring keys needs to be signed with the master key | |
55 | # (otherwise it does not make sense from a security POV) | |
56 | net_update() { | |
57 | if [ -z "$ARCHIVE_KEYRING_URI" ]; then | |
58 | echo "ERROR: no location for the archive-keyring given" | |
59 | fi | |
60 | if [ ! -d /var/lib/apt/keyrings ]; then | |
61 | mkdir -p /var/lib/apt/keyrings | |
62 | fi | |
63 | keyring=/var/lib/apt/keyrings/$(basename $ARCHIVE_KEYRING) | |
64 | old_mtime=0 | |
65 | if [ -e $keyring ]; then | |
66 | old_mtime=$(stat -c %Y $keyring) | |
67 | fi | |
68 | (cd /var/lib/apt/keyrings; wget -q -N $ARCHIVE_KEYRING_URI) | |
69 | if [ ! -e $keyring ]; then | |
70 | return | |
71 | fi | |
72 | new_mtime=$(stat -c %Y $keyring) | |
73 | if [ $new_mtime -ne $old_mtime ]; then | |
74 | echo "Checking for new archive signing keys now" | |
75 | add_keys_with_verify_against_master_keyring $keyring $MASTER_KEYRING | |
76 | fi | |
77 | } | |
78 | ||
79 | update() { | |
80 | if [ ! -f $ARCHIVE_KEYRING ]; then | |
81 | echo >&2 "ERROR: Can't find the archive-keyring" | |
82 | echo >&2 "Is the debian-archive-keyring package installed?" | |
83 | exit 1 | |
84 | fi | |
85 | ||
86 | # add new keys from the package; | |
87 | ||
88 | # we do not use add_keys_with_verify_against_master_keyring here, | |
89 | # because "update" is run on regular package updates. A | |
90 | # attacker might as well replace the master-archive-keyring file | |
91 | # in the package and add his own keys. so this check wouldn't | |
92 | # add any security. we *need* this check on net-update though | |
93 | $GPG_CMD --quiet --batch --keyring $ARCHIVE_KEYRING --export | $GPG --import | |
94 | ||
95 | # remove no-longer supported/used keys | |
96 | keys=`$GPG_CMD --keyring $REMOVED_KEYS --with-colons --list-keys | grep ^pub | cut -d: -f5` | |
97 | for key in $keys; do | |
98 | if $GPG --list-keys --with-colons | grep ^pub | cut -d: -f5 | grep -q $key; then | |
99 | $GPG --quiet --batch --delete-key --yes ${key} | |
100 | fi | |
101 | done | |
102 | } | |
103 | ||
104 | ||
105 | usage() { | |
106 | echo "Usage: apt-key [command] [arguments]" | |
107 | echo | |
108 | echo "Manage apt's list of trusted keys" | |
109 | echo | |
110 | echo " apt-key add <file> - add the key contained in <file> ('-' for stdin)" | |
111 | echo " apt-key del <keyid> - remove the key <keyid>" | |
112 | echo " apt-key export <keyid> - output the key <keyid>" | |
113 | echo " apt-key exportall - output all trusted keys" | |
114 | echo " apt-key update - update keys using the keyring package" | |
115 | echo " apt-key net-update - update keys using the network" | |
116 | echo " apt-key list - list keys" | |
117 | echo " apt-key finger - list fingerprints" | |
118 | echo " apt-key adv - pass advanced options to gpg (download key)" | |
119 | echo | |
120 | } | |
121 | ||
122 | command="$1" | |
123 | if [ -z "$command" ]; then | |
124 | usage | |
125 | exit 1 | |
126 | fi | |
127 | shift | |
128 | ||
129 | if [ "$command" != "help" ] && ! which gpg >/dev/null 2>&1; then | |
130 | echo >&2 "Warning: gnupg does not seem to be installed." | |
131 | echo >&2 "Warning: apt-key requires gnupg for most operations." | |
132 | echo >&2 | |
133 | fi | |
134 | ||
135 | case "$command" in | |
136 | add) | |
137 | $GPG --quiet --batch --import "$1" | |
138 | echo "OK" | |
139 | ;; | |
140 | del|rm|remove) | |
141 | $GPG --quiet --batch --delete-key --yes "$1" | |
142 | echo "OK" | |
143 | ;; | |
144 | update) | |
145 | update | |
146 | ;; | |
147 | net-update) | |
148 | net_update | |
149 | ;; | |
150 | list) | |
151 | $GPG --batch --list-keys | |
152 | ;; | |
153 | finger*) | |
154 | $GPG --batch --fingerprint | |
155 | ;; | |
156 | export) | |
157 | $GPG --armor --export "$1" | |
158 | ;; | |
159 | exportall) | |
160 | $GPG --armor --export | |
161 | ;; | |
162 | adv*) | |
163 | echo "Executing: $GPG $*" | |
164 | $GPG $* | |
165 | ;; | |
166 | help) | |
167 | usage | |
168 | ;; | |
169 | *) | |
170 | usage | |
171 | exit 1 | |
172 | ;; | |
173 | esac |